function [betax_est,betaX_est,betaZ_est,betamu_est,betax,betaX,betaZ,betamu,v0_est,v0_upper,v0_lower,v_est,v_upper,v_lower,urate,u_est,ypred,linkpred,lppred,v0_pred,v0_pred_upper,v0_pred_lower,v_pred,v_pred_upper,v_pred_lower,u_pred,u_pred_rate,t_est,sigma_est]=postMCMC_sameX(y,u,x,z,cutoff,ut,xt,zt,lin_est,nlin_est,categ_est,const_est,Npo,burninpo,seed,family,eta_sd,xi_sd,t_sd,sigma_var)


%why not set ll_old=ll_new when updating t



% t_sd = .25/2;
% eta_sd = .25/2;
% sigma_var=.2/2;
ifpredy=1;%predict or not
if isempty(ut)
    ifpredy=0;
end
ifpredu=1;%predict or not
if isempty(xt)&&isempty(zt)
    ifpredu=0;
end
rel = version('-release');
if (all(rel>='2011a'))
    rng('default');
    rng(seed);
end

[n,p]=size(u);
q = size(x,2);
r = size(z,2);
% xi_sd = .2;%1/sqrt(q)/1.5; %was .5 .2

%design matrix
inte = ones(n,1)/sqrt(n);%intercept
%categorical
Z = double.empty(n,0);
Zind = [];
zmean = [];
zscale = [];
for i =1:r
    try
        Ztmp = dummyvar(z(:,i));
        Ztmp = Ztmp(:,2:end);
    catch
        Ztmp=z(:,i);
    end
    zmean = [zmean,mean(Ztmp)];
    Ztmp = Ztmp-repmat(mean(Ztmp),n,1);
    %zscale = [zscale,norm(Ztmp,'fro')*sqrt(n)/2*ones(1,size(Ztmp,2))];
    %Ztmp = Ztmp/norm(Ztmp,'fro')*sqrt(n)/2;
    zscale = [zscale,norm(Ztmp,'fro')*ones(1,size(Ztmp,2))];
    Ztmp = Ztmp/norm(Ztmp,'fro');
    Z = [Z,Ztmp];
    Zind = [Zind;i*ones(size(Ztmp,2),1)];
end
%continuous
order = 4; %order of splines
nknots = 16; %number of interior knots
M = order + nknots;
xx=bspline_quantileknots(order,nknots,x,x);
%xx = xx-repmat(mean(xx),[n,1]);
if ifpredu==1
    xxt=bspline_quantileknots(order,nknots,x,xt);
end
K = makeK(M);
Kinv = pinv(K);
X = double.empty(n,0);
Xind =[];
%x= x-repmat(mean(x),[n,1]);
for i = 1:q
    Xtmp = xx(:,(i-1)*M+1:i*M);
    [U,S,~]=svd(Xtmp*Kinv*Xtmp','econ');
    S = diag(S);
    nullvals = S < 10^-10;
    d = max(3, find( cumsum(S(~nullvals))/sum(S(~nullvals)) > .995 ,1));
    d = min(d, sum(~nullvals));
    Xtmp = U(:,1:d)*diag(sqrt(S(1:d)));
    Xtmp2 = [ones(n,1),x(:,i)];
    Xtmp = Xtmp- Xtmp2*(Xtmp2\Xtmp);
    Xtmp = Xtmp/norm(Xtmp,'fro');
    x(:,i) = x(:,i)-mean(x(:,i));
    x(:,i) = x(:,i)/norm(x(:,i),'fro');
    X = [X,Xtmp];
    Xind = [Xind;i*ones(size(Xtmp,2),1)];
end

%W=[x,X,Z];
dX = size(X,2);
dZ = size(Z,2);
%parameter
a_t = 0; b_t = .5;%uniform prior for t
a = 10^-4; b = 10^-4;%IG prior for sigma
a_tau = 5; b_tau = 25;
s0 = 1*10^-4;

etax_old = .1*randn(q,p);
etaX_old = .1*randn(q,p);
etaZ_old = .1*randn(r,p);
etamu_old = .1*randn(p,1);

xix_old = .1*randn(q,p);
xiX_old = .1*randn(dX,p);
xiZ_old = .1*randn(dZ,p);
ximu_old = .1*randn(p,1);
betax = zeros(q,p,(Npo-burninpo));
betaX = zeros(dX,p,(Npo-burninpo));
betaZ = zeros(dZ,p,(Npo-burninpo));
betamu = zeros(p,(Npo-burninpo));
betax_old = etax_old.*xix_old;
betaX_old = etaX_old(Xind,:).*xiX_old;
betaZ_old = etaZ_old(Zind,:).*xiZ_old;
betamu_old = etamu_old.*ximu_old;
for i = 1:q
    xibar=mean(abs(xix_old(i,:)),1);
    etax_old(i,:) = etax_old(i,:).*xibar;
    xix_old(i,:) = xix_old(i,:)./xibar;
    xibar=mean(abs(xiX_old(Xind==i,:)),1);
    etaX_old(i,:) = etaX_old(i,:).*xibar;
    xiX_old(Xind==i,:) = xiX_old(Xind==i,:)./repmat(xibar,[sum(Xind==i),1]);
end
for i = 1:r
    xibar=mean(abs(xiZ_old(Zind==i,:)),1);
    etaZ_old(i,:) = etaZ_old(i,:).*xibar;
    xiZ_old(Zind==i,:) = xiZ_old(Zind==i,:)./repmat(xibar,[sum(Zind==i),1]);
    
end
etamu_old = etamu_old.*abs(ximu_old);
ximu_old = ximu_old./abs(ximu_old);

sigma = ones((Npo-burninpo),1);%sigma^2
t = zeros((Npo-burninpo),1);
t_old=t(1);

gammax_old = lin_est+0;
gammaX_old = nlin_est+0;
gammaZ_old = categ_est+0;
gammamu_old = const_est+0;
gammax_old(gammax_old==0)=s0;
gammaX_old(gammaX_old==0)=s0;
gammaZ_old(gammaZ_old==0)=s0;
gammamu_old(gammamu_old==0)=s0;
v = zeros(n,p,(Npo-burninpo));
v0 = zeros(n,p,(Npo-burninpo));
ac_eta=0;
ac_xi =0;
ac_t=0;
ac_sigma=0;
sigma_old = sigma(1);
taux_old = ones(q,p);
tauX_old = ones(q,p);
tauZ_old = ones(r,p);
taumu_old = ones(p,1);
regressor_old=zeros(n,p);
for j = 1:p
    regressor_old(:,j) = u(:,j).*threshold(betamu_old(j)*inte+x*betax_old(:,j)+X*betaX_old(:,j)+Z*betaZ_old(:,j),t_old);
end
%algorithm begins
%tic;
ll_old = loglike(y,regressor_old,sigma_old,family);
iter=0;
for mc = 2:Npo
    %update eta
    
        for i = 1:q
            for j = 1:p
                regressor_new = regressor_old;
                etax_new = etax_old(:,j);
                etax_new(i) = etax_old(i,j) + eta_sd*randn(1);
                betax_new = etax_new.*xix_old(:,j);
                regressor_new(:,j) = u(:,j).*threshold(betamu_old(j)*inte+x*betax_new+X*betaX_old(:,j)+Z*betaZ_old(:,j),t_old);
                ll_new = loglike(y,regressor_new,sigma_old,family);
                lr = ll_new-ll_old-.5*(etax_new(i).^2./gammax_old(i,j)./taux_old(i,j))...
                    +.5*(etax_old(i,j).^2./gammax_old(i,j)./taux_old(i,j));
                if lr > log(rand(1))
                    ac_eta = ac_eta+1;
                    ll_old=ll_new;
                    etax_old(i,j) = etax_new(i);
                    betax_old(:,j) = betax_new;
                    regressor_old(:,j) = regressor_new(:,j);
                end
            end
        end
        for i = 1:q
            for j = 1:p
                regressor_new = regressor_old;
                etaX_new = etaX_old(:,j);
                etaX_new(i) = etaX_old(i,j) + eta_sd*randn(1);
                betaX_new = etaX_new(Xind).*xiX_old(:,j);
                regressor_new(:,j) = u(:,j).*threshold(betamu_old(j)*inte+x*betax_old(:,j)+X*betaX_new+Z*betaZ_old(:,j),t_old);
                ll_new = loglike(y,regressor_new,sigma_old,family);
                lr = ll_new-ll_old-.5*(etaX_new(i).^2./gammaX_old(i,j)./tauX_old(i,j))...
                    +.5*(etaX_old(i,j).^2./gammaX_old(i,j)./tauX_old(i,j));
                if lr > log(rand(1))
                    ac_eta = ac_eta+1;
                    ll_old=ll_new;
                    etaX_old(i,j) = etaX_new(i);
                    betaX_old(:,j) = betaX_new;
                    regressor_old(:,j) = regressor_new(:,j);
                end
            end
        end
        for i = 1:r
            for j = 1:p
                regressor_new = regressor_old;
                etaZ_new = etaZ_old(:,j);
                etaZ_new(i) = etaZ_old(i,j) + eta_sd*randn(1);
                betaZ_new = etaZ_new(Zind).*xiZ_old(:,j);
                regressor_new(:,j) = u(:,j).*threshold(betamu_old(j)*inte+x*betax_old(:,j)+X*betaX_old(:,j)+Z*betaZ_new,t_old);
                ll_new = loglike(y,regressor_new,sigma_old,family);
                lr = ll_new-ll_old-.5*(etaZ_new(i).^2./gammaZ_old(i,j)./tauZ_old(i,j))...
                    +.5*(etaZ_old(i,j).^2./gammaZ_old(i,j)./tauZ_old(i,j));
                if lr > log(rand(1))
                    ac_eta = ac_eta+1;
                    ll_old=ll_new;
                    etaZ_old(i,j) = etaZ_new(i);
                    betaZ_old(:,j) = betaZ_new;
                    regressor_old(:,j) = regressor_new(:,j);
                end
            end
        end
        for j = 1:p
            regressor_new = regressor_old;
            etamu_new = etamu_old(j) + eta_sd*randn(1);
            betamu_new = etamu_new.*ximu_old(j);
            regressor_new(:,j) = u(:,j).*threshold(betamu_new*inte+x*betax_old(:,j)+X*betaX_old(:,j)+Z*betaZ_old(:,j),t_old);
            ll_new = loglike(y,regressor_new,sigma_old,family);
            lr = ll_new-ll_old-.5*(etamu_new.^2./gammamu_old(j)./taumu_old(j))...
                +.5*(etamu_old(j).^2./gammamu_old(j)./taumu_old(j));
            if lr > log(rand(1))
                ac_eta = ac_eta+1;
                ll_old=ll_new;
                etamu_old(j) = etamu_new;
                betamu_old(j) = betamu_new;
                regressor_old(:,j) = regressor_new(:,j);
            end
        end
    
    %update
    mx_old=2*binornd(1,1./(1+exp(-2*xix_old)))-1;
    mX_old=2*binornd(1,1./(1+exp(-2*xiX_old)))-1;
    mZ_old=2*binornd(1,1./(1+exp(-2*xiZ_old)))-1;
    mmu_old=2*binornd(1,1./(1+exp(-2*ximu_old)))-1;
%     mx_old=mx_old*0;
%     mX_old=mX_old*0;
%     mZ_old=mZ_old*0;
%     mmu_old=mmu_old*0;
    %update xi
    for i = 1:q
        for j = 1:p      
            regressor_new = regressor_old;
            xix_new = xix_old(:,j);
            xix_new(i) = xix_old(i,j) + xi_sd*randn(1);
            betax_new = etax_old(:,j).*xix_new;           
            regressor_new(:,j) = u(:,j).*threshold(betamu_old(j)*inte+x*betax_new+X*betaX_old(:,j)+Z*betaZ_old(:,j),t_old);
            ll_new = loglike(y,regressor_new,sigma_old,family);
            lr = ll_new-ll_old-.5*(xix_new(i)-mx_old(i,j)).^2+.5*(xix_old(i,j)-mx_old(i,j)).^2;
            if lr > log(rand(1))
                ac_xi = ac_xi+1;
                ll_old=ll_new;
                xix_old(:,j) = xix_new;
                betax_old(:,j) = betax_new;
                regressor_old(:,j) = regressor_new(:,j);
            end
        end
    end
    
    for i = 1:q
        for j = 1:p
            regressor_new = regressor_old;
            xiX_new = xiX_old(:,j);
            ind = (Xind==i);
            xiX_new(ind) = xiX_old(ind,j) + xi_sd*randn(sum(ind),1);
            betaX_new = etaX_old(Xind,j).*xiX_new;
            regressor_new(:,j) = u(:,j).*threshold(betamu_old(j)*inte+x*betax_old(:,j)+X*betaX_new+Z*betaZ_old(:,j),t_old);
            ll_new = loglike(y,regressor_new,sigma_old,family);
            lr = ll_new-ll_old-.5*sum((xiX_new(ind)-mX_old(ind,j)).^2)+.5*sum((xiX_old(ind,j)-mX_old(ind,j)).^2);
            if lr > log(rand(1))
                ac_xi = ac_xi+1;
                ll_old=ll_new;
                xiX_old(:,j) = xiX_new;
                betaX_old(:,j) = betaX_new;
                regressor_old(:,j) = regressor_new(:,j);
            end
        end
    end
        
        
        
    for i = 1:r
        for j = 1:p
            regressor_new = regressor_old;
            xiZ_new = xiZ_old(:,j);
            ind = (Zind==i);
            xiZ_new(ind) = xiZ_old(ind,j) + xi_sd*randn(sum(ind),1);
            betaZ_new = etaZ_old(Zind,j).*xiZ_new;
            regressor_new(:,j) = u(:,j).*threshold(betamu_old(j)*inte+x*betax_old(:,j)+X*betaX_old(:,j)+Z*betaZ_new,t_old);
            ll_new = loglike(y,regressor_new,sigma_old,family);
            lr = ll_new-ll_old-.5*sum((xiZ_new(ind)-mZ_old(ind,j)).^2)+.5*sum((xiZ_old(ind,j)-mZ_old(ind,j)).^2);
            if lr > log(rand(1))
                ac_xi = ac_xi+1;
                ll_old=ll_new;
                xiZ_old(:,j) = xiZ_new;
                betaZ_old(:,j) = betaZ_new;
                regressor_old(:,j) = regressor_new(:,j);
            end
        end
    end
     
    for j = 1:p
        regressor_new = regressor_old;
        ximu_new = ximu_old(j) + xi_sd*randn(1);
        betamu_new = etamu_old(j).*ximu_new;
        regressor_new(:,j) = u(:,j).*threshold(betamu_new*inte+x*betax_old(:,j)+X*betaX_old(:,j)+Z*betaZ_old(:,j),t_old);
        ll_new = loglike(y,regressor_new,sigma_old,family);
        lr = ll_new-ll_old-.5*(ximu_new-mmu_old(j)).^2+.5*(ximu_old(j)-mmu_old(j)).^2;
        if lr > log(rand(1))
            ac_xi = ac_xi+1;
            ll_old=ll_new;
            ximu_old(j) = ximu_new;
            betamu_old(j) = betamu_new;
            regressor_old(:,j) = regressor_new(:,j);
        end
    end
    
    
    %rescale eta and xi
    
    for i = 1:q
        xibar=mean(abs(xix_old(i,:)),1);
        etax_old(i,:) = etax_old(i,:).*xibar;
        xix_old(i,:) = xix_old(i,:)./xibar;
        xibar=mean(abs(xiX_old(Xind==i,:)),1);
        etaX_old(i,:) = etaX_old(i,:).*xibar;
        xiX_old(Xind==i,:) = xiX_old(Xind==i,:)./repmat(xibar,[sum(Xind==i),1]);
    end
    for i = 1:r
        xibar=mean(abs(xiZ_old(Zind==i,:)),1);
        etaZ_old(i,:) = etaZ_old(i,:).*xibar;
        xiZ_old(Zind==i,:) = xiZ_old(Zind==i,:)./repmat(xibar,[sum(Zind==i),1]);
    end
    etamu_old = etamu_old.*abs(ximu_old);
    ximu_old = ximu_old./abs(ximu_old);
    
    %update t
    t_new = rtnorm(t_old,t_sd,a_t,b_t);
    regressor_new = u.*threshold(kron(betamu_old',inte)+x*betax_old+X*betaX_old+Z*betaZ_old,t_new);
    ll_new = loglike(y,regressor_new,sigma_old,family);
    lr = ll_new-ll_old + log(dtnorm(t_old,t_new,t_sd,a_t,b_t)) - log(dtnorm(t_new,t_old,t_sd,a_t,b_t));
    if lr>log(rand(1))
        ac_t = ac_t + 1;
        t_old = t_new;
        regressor_old = regressor_new;
    end
    %t_old = 0;
    
    %update tau
    taux_old=1./gamrnd(a_tau+.5,1./(b_tau+etax_old.^2./gammax_old/2));
    tauX_old=1./gamrnd(a_tau+.5,1./(b_tau+etaX_old.^2./gammaX_old/2));
    tauZ_old=1./gamrnd(a_tau+.5,1./(b_tau+etaZ_old.^2./gammaZ_old/2));
    taumu_old=1./gamrnd(a_tau+.5,1./(b_tau+etamu_old.^2./gammamu_old/2));
    
    
    %update sigma
    if family=='n'
        sse = -(ll_old+.5*log(sigma_old))*2*sigma_old;
        sigma_old = 1/gamrnd(a+n/2,1/(b+sse/2));
        ll_old = -sse/2/sigma_old-.5*log(sigma_old);
    elseif family=='w'
        mm = log(sigma_old^2/sqrt(sigma_var+sigma_old^2));
        vv = sqrt(log(sigma_var/sigma_old^2+1));
        sigma_new = lognrnd(mm,vv);
        mm2 = log(sigma_new^2/sqrt(sigma_var+sigma_new^2));
        vv2 = sqrt(log(sigma_var/sigma_new^2+1));
        ll_new = loglike(y,regressor_old,sigma_new,family);
        lr = ll_new-ll_old + log(gampdf(sigma_new,a,1/b)) - log(gampdf(sigma_old,a,1/b))-log(lognpdf(sigma_new,mm,vv))+log(lognpdf(sigma_old,mm2,vv2)) ;
        if lr>log(rand(1))
            ac_sigma = ac_sigma + 1;
            sigma_old = sigma_new;
            ll_old=ll_new;
        end    
    elseif family=='l'
        mm = log(sigma_old^2/sqrt(sigma_var+sigma_old^2));
        vv = sqrt(log(sigma_var/sigma_old^2+1));
        sigma_new = lognrnd(mm,vv);
        mm2 = log(sigma_new^2/sqrt(sigma_var+sigma_new^2));
        vv2 = sqrt(log(sigma_var/sigma_new^2+1));
        ll_new = loglike(y,regressor_old,sigma_new,family);
        lr = ll_new-ll_old + log(gampdf(1/sigma_new,a,1/b)) - log(gampdf(1/sigma_old,a,1/b))-log(lognpdf(sigma_new,mm,vv))+log(lognpdf(sigma_old,mm2,vv2)) ;
        if lr>log(rand(1))
            ac_sigma = ac_sigma + 1;
            sigma_old = sigma_new;
            ll_old=ll_new;
        end
    end
    
    
    if mod(mc,200)==0
        fprintf('%d steps finished\n',mc)
        fprintf('%d steps to go\n',Npo-mc)
    end
    %save samples every "thin" iterations
    if mc>burninpo
        iter = iter + 1;
        betax(:,:,iter)=betax_old;
        betaX(:,:,iter)=betaX_old;
        betaZ(:,:,iter)=betaZ_old;
        betamu(:,iter)=betamu_old;
        t(iter) = t_old;
        sigma(iter) = sigma_old;
        v0(:,:,iter) = kron((betamu_old.*(gammamu_old==1))',inte)+x*(betax_old.*(gammax_old==1))+X*(betaX_old.*(gammaX_old(Xind,:)==1))+Z*(betaZ_old.*(gammaZ_old(Zind,:)==1));
        v(:,:,iter) = threshold(v0(:,:,iter),t_old);
    end
end
ac_eta = ac_eta/(Npo-1)/p*2/(2*q+r+1);
ac_xi = ac_xi/(Npo-1)/p*2/(2*q+r+1);
ac_t = ac_t/(Npo-1);
ac_sigma = ac_sigma/(Npo-1);


betax_est = mean(betax,3);
betaX_est = mean(betaX,3);
betaZ_est = mean(betaZ,3);
betamu_est = mean(betamu,2);

% betax_sd = std(betax_est,0,3);
% betaX_sd = std(betaX_est,0,3);
% betaZ_sd = std(betaZ_est,0,3);
% betamu_sd = std(betamu_est,0,2);


% v0_est = mean(v0,3);
% v0_upper = v0_est + 1.96*std(v0,0,3);
% v0_lower = v0_est - 1.96*std(v0,0,3);

t_est = mean(t);
sigma_est = mean(sigma);
urate = 0;%regression strucutre
for mc = 1:(Npo-burninpo)
    urate = urate+(v(:,:,mc)~=0);
end
urate = urate/(Npo-burninpo);
u_est=urate>cutoff;




v_est = mean(v,3);
vsd = std(v,0,3);
v_upper = v_est+1.96*vsd;
v_lower = v_est-1.96*vsd;
v0_est=mean(v0,3);
vsd = std(v0,0,3);
v0_upper = v0_est+1.96*vsd;
v0_lower = v0_est-1.96*vsd;

% v_est=zeros(n,p);
% v0_est = v_est;
% v0_upper=v_est;
% v0_lower=v_est;
% v_upper=v_est;
% v_lower=v_est;
% v0_tmp = zeros(n,p,Npo-burninpo);
% v_tmp = v0_tmp;
%
%
%
%
%
% %v_est=zeros(n,p);
% countv=zeros(n,p);
% for mc = 1:(Npo-burninpo)
%     for i =1 :n
%         for j = 1:p
%         if 1%all(all(u_est(i,j)==(v(i,j,mc)~=0)))
%             countv(i,j)=countv(i,j)+1;
%             v_est(i,j) = v_est(i,j)+v(i,j,mc);
%             v0_est(i,j) = v0_est(i,j)+v0(i,j,mc);
%             v0_tmp(i,j,countv(i,j)) = v0(i,j,mc);
%             v_tmp(i,j,countv(i,j)) = v(i,j,mc);
%         end
%         end
%     end
% end
% v_est = v_est./countv;
% v0_est = v0_est./countv;
%
% for i = 1:n
%     for j = 1:p
%     v0_upper(i,j) = v0_est(i,j)+1.96*std(squeeze(v0_tmp(i,j,1:countv(i,j))));
%     v0_lower(i,j) = v0_est(i,j)-1.96*std(squeeze(v0_tmp(i,j,1:countv(i,j))));
%     v_upper(i,j) = v_est(i,j)+1.96*std(squeeze(v_tmp(i,j,1:countv(i,j))));
%     v_lower(i,j) = v_est(i,j)-1.96*std(squeeze(v_tmp(i,j,1:countv(i,j))));
%     end
% end
% countv=zeros(n,1);
% for mc = 1:(Npo-burninpo)
%     for i = 1:n
%         if all(all(u_est(i,:)==(v(i,:,mc)~=0)))
%             countv(i)=countv(i)+1;
%             v_est(i,:) = v_est(i,:)+v(i,:,mc);
%             v0_est(i,:) = v0_est(i,:)+v0(i,:,mc);
%             v0_tmp(i,:,countv(i)) = v0(i,:,mc);
%             v_tmp(i,:,countv(i)) = v(i,:,mc);
%         end
%     end
% end
% v_est = v_est./repmat(countv,[1,p]);
% v0_est = v0_est./repmat(countv,[1,p]);
%v_est = kron((betamu_est)',inte)+x*(betax_est)+X*(betaX_est)+Z*(betaZ_est);
%prediction

alpha=zeros(q*M,p,(Npo-burninpo));
[Q,R] = qr(xx,0);
for j = 1:p
    for mc = 1:(Npo-burninpo)
        alpha(:,j,mc) = R\(Q'*(betamu(j,mc)*inte+X*squeeze(betaX(:,j,mc))+x*betax(:,j,mc)));
    end
end




% alpha=zeros(q,p,M,(N-burninpo)/thin);
% for k = 1:q
%     Xtmp = xx(:,(k-1)*M+1:k*M);
%     Xtmp = (Xtmp'*Xtmp)\Xtmp';
%     Xtmp1 = Xtmp*X(:,Xind==k);
%     Xtmp2 = Xtmp*x(:,k);
%     for j = 1:p
%         alpha(k,j,:,:)=Xtmp1*squeeze(betaX(Xind==k,j,:))+Xtmp2*squeeze(betax(k,j,:))';
%     end
% end
% alpha = reshape(permute(alpha,[3,1,2,4]),q*M,p,(N-burninpo)/thin);
if ifpredu==1
    nt = size(ut,1);
    lppred=zeros(nt,1);
    Zt = double.empty(nt,0);
    if r~=0
        for i =1:r
            try
                Ztmp = dummyvar(zt(:,i));
                Ztmp = Ztmp(:,2:end);
            catch
                Ztmp = zt(:,i);
            end
            Zt = [Zt,Ztmp];
        end
        Zt = Zt-repmat(zmean,nt,1);
        Zt = Zt./repmat(zscale,nt,1);
    end
    ypred=zeros(nt,1);
    u_pred_rate=zeros(nt,p);
    vtmp=zeros(nt,p,(Npo-burninpo));
    v0tmp=zeros(nt,p,(Npo-burninpo));
    for mc = 1:(Npo-burninpo)
        if q~=0
            v0tmp(:,:,mc) = Zt*betaZ(:,:,mc) + xxt*alpha(:,:,mc);
            vtmp(:,:,mc) = threshold(v0tmp(:,:,mc),t(mc));
        else
            v0tmp(:,:,mc) = Zt*betaZ(:,:,mc) + kron(betamu(:,mc)',inte);
            vtmp(:,:,mc) = threshold(v0tmp(:,:,mc),t(mc));
        end
        if ifpredy==1
            lppred = lppred + sum(ut.*vtmp(:,:,mc),2);%response
        end
        u_pred_rate = u_pred_rate+(vtmp(:,:,mc)~=0);
    end
    if ifpredy==1
        lppred = lppred/((Npo-burninpo));
    else
        lppred=nan;
    end
    u_pred_rate = u_pred_rate/((Npo-burninpo));
    u_pred=u_pred_rate>cutoff;
    
    %     v_pred=zeros(nt,p);
    %     v0_pred = v_pred;
    %     v0_pred_upper=v_pred;
    %     v0_pred_lower=v_pred;
    %     v_pred_upper=v_pred;
    %     v_pred_lower=v_pred;
    %     v0_tmp = zeros(nt,p,Npo-burninpo);
    %     v_tmp = v0_tmp;
    %     countv_pred=zeros(nt,p);
    %     for mc = 1:(Npo-burninpo)
    %         for i = 1:nt
    %             for j = 1:p
    %             if u_pred(i,j)==(vtmp(i,j,mc)~=0)
    %                 countv_pred(i,j)=countv_pred(i,j)+1;
    %                 v_pred(i,j) = v_pred(i,j)+vtmp(i,j,mc);
    %                 v0_pred(i,j) = v0_pred(i,j)+v0tmp(i,j,mc);
    %                 v0_tmp(i,j,countv_pred(i,j)) = v0tmp(i,j,mc);
    %                 v_tmp(i,j,countv_pred(i,j)) = vtmp(i,j,mc);
    %             end
    %             end
    %         end
    %     end
    %     v_pred = v_pred./countv_pred;
    %     v0_pred = v0_pred./countv_pred;
    %     for i = 1:nt
    %         for j = 1:p
    %             v0_pred_upper(i,j) = v0_pred(i,j)+1.96*std(squeeze(v0_tmp(i,j,1:countv_pred(i,j))));
    %             v0_pred_lower(i,j) = v0_pred(i,j)-1.96*std(squeeze(v0_tmp(i,j,1:countv_pred(i,j))));
    %             v_pred_upper(i,j) = v_pred(i,j)+1.96*std(squeeze(v_tmp(i,j,1:countv_pred(i,j))));
    %             v_pred_lower(i,j) = v_pred(i,j)-1.96*std(squeeze(v_tmp(i,j,1:countv_pred(i,j))));
    %         end
    %     end
    v_pred = mean(vtmp,3);
    vsd = std(vtmp,0,3);
    v_pred_upper = v_pred+1.96*vsd;
    v_pred_lower = v_pred-1.96*vsd;
    v0_pred = mean(v0tmp,3);
    vsd = std(v0tmp,0,3);
    v0_pred_upper = v0_pred+1.96*vsd;
    v0_pred_lower = v0_pred-1.96*vsd;
    if family=='n'
        ypred = lppred;
        linkpred = lppred;
    elseif family=='b'
        linkpred=1./(1+exp(-lppred));
        ypred = linkpred>.5;%optimal classification rate prediction
    elseif family=='p'
        linkpred = exp(lppred);
        ypred = linkpred;
    elseif family=='w'
        linkpred = exp(lppred);
        ypred = gamma(1+sigma_est)./linkpred;
    elseif family=='l'
        linkpred = exp(lppred);
        ypred = linkpred; %probably this is wrong (just copied from weibull)
    end
else
    ypred=nan;
    linkpred=nan;
    lppred=nan;
    v_pred=nan;
    v0_pred=nan;
    v_pred_upper=nan;
    v_pred_lower=nan;
    v0_pred_upper=nan;
    v0_pred_lower=nan;
    u_pred=nan;
    u_pred_rate=nan;
end




% v0_est=kron((betamu_est.*(gammamu_old==1))',inte)+x*(betax_est.*(gammax_old==1))+X*(betaX_est.*(gammaX_old(Xind,:)==1))+Z*(betaZ_est.*(gammaZ_old(Zind,:)==1));
% v0_upper = kron((betamu_est+1.96*betamu_sd)',inte)+x*(betax_est+1.96*betax_sd)+X*(betaX_est+1.96*betaX_sd)+Z*(betaZ_est+1.96*betaZ_sd);
% v0_lower = kron((betamu_est-1.96*betamu_sd)',inte)+x*(betax_est-1.96*betax_sd)+X*(betaX_est-1.96*betaX_sd)+Z*(betaZ_est-1.96*betaZ_sd);


